\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{colortbl}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 4a - BGP Security}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 4a - BGP Security}
\date{Version 1.2 - Students Copy}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle
\section{Introduction}
In this series of experiments we protect our BGP setup against malicious BGP announcements and other various threats from the Internet.


\section{Network Setup}
\begin{figure}[htp]
  \centering
  \includegraphics[width=\linewidth,page=1]{img/04-communities-drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment.
Two upstreams, one customer and everybody peers with each other.

\section{Security Measures}
\subsection{Maximum Prefix}
To configure maximum prefix use the \emph{maximum-prefix} statement for either a single peer or a peer-group in address-family context:
\begin{description}
  \item[neighbor \emph{<ip address> | <peergroup-name>} maximum-prefix \emph{<threshold> <warning-percentage>} restart \emph{<restart-time>}]
  defines a maximum prefix for either \emph{<ip address>} (can be IPv4 or IPv6) or a whole peer group:
  \begin{description}
    \item[\emph{<threshold>}] is the number of prefixes you allow from this peer or peer group. If more are received the BGP session is shut down.
    \item[\emph{<warning-percentage>}] is optional - if this percentage of \emph{<threshold>} prefixes are received the router loggs a warning message.
    \item[restart \emph{<restart time>}] is also optional (but recommended); if it is missing the BGP session stays down until manual intervention (using a \emph{clear} command). It configures the number of minutes after which the BGP session is made active again.
  \end{description}
\end{description}

\subsection{MD5 Session Passwort}
This is usually done for each individual peer (it would only make sense doing this for a peer-group in case of iBGP). You put the password \emph{outside} of any address-family context:
\begin{description}
  \item[neighbor \emph{<ip address> | <peergroup-name>} password \emph{<some password>}] this configures an MD5 password on the TCP session to the neighbor. Be aware this becomes active immediately so the BGP session will drop. The neighbor has to configure the same password.
\end{description}
Keep in mind that you need a functioning and maintained password management if you use session passwords in production. Usually the effort is not worth it and TTL security (see next section) can achieve the same.

\subsection{TTL security}
To ensure that a BGP peer is a specific number of hops away (usually in eBGP exactly one hop) the TTL counter of IP packets can be used. For a hop of one: if packets are sent with a TTL of 255 and not received with TTL of 255 they are discarded. For a hop of two, 255 and 254 as TTL are allowed and so on.

Configuration commands:
\begin{description}
  \item[neighbor \emph{<ip address> | <peergroup-name>} ttl-security hops \emph{<hopnumber>}] - this allows the neighbor to be maximum \emph{<hopnumber>} hops away. TTL security needs to be configured on both sides of a BGP session.
\end{description}


\appendix
\section{Initial Router Configuration}
(instead of XX insert your router number)
\begin{verbatim}
hostname rXX
!
ip route 10.XX.0.0/16 Null0
!
interface dummy0
 ip address 10.XX.1.1/32
!
router bgp 645XX
 neighbor customer peer-group
 neighbor peering peer-group
 neighbor upstream peer-group
 neighbor 10.XX.2.1 remote-as 64499
 neighbor 10.XX.2.1 peer-group customer
 neighbor 80.81.192.1 remote-as 286
 neighbor 80.81.192.1 peer-group peering
 neighbor 80.81.192.102 remote-as 64502
 neighbor 80.81.192.102 peer-group peering
 ...
 neighbor 10.200.XX.1 remote-as 65550
 neighbor 10.200.XX.1 peer-group upstream
 neighbor 10.230.XX.1 remote-as 64496
 neighbor 10.230.XX.1 peer-group upstream
 !
 address-family ipv4 unicast
  network 10.XX.0.0/16 route-map own-networks
  neighbor customer next-hop-self
  neighbor customer soft-reconfiguration inbound
  neighbor customer route-map customer-in in
  neighbor customer route-map customer-out out
  neighbor peering next-hop-self
  neighbor peering soft-reconfiguration inbound
  neighbor peering route-map peering-in in
  neighbor peering route-map peering-out out
  neighbor upstream next-hop-self
  neighbor upstream soft-reconfiguration inbound
  neighbor upstream route-map upstream-in in
  neighbor upstream route-map upstream-out out
 exit-address-family
!
bgp community-list expanded announce-to-customer permit _645XX:4[1357]000
bgp community-list expanded announce-to-peering permit _645XX:4[2367]000
bgp community-list expanded announce-to-upstream permit _645XX:4[4567]000
bgp community-list expanded my-communities permit _645XX:.*
bgp large-community-list expanded my-largecommunities permit _645XX:.*:.*
!
route-map upstream-in permit 50
 match community my-communities
 set comm-list my-communities delete
 on-match next
!
route-map upstream-in permit 60
 match large-community my-largecommunities
 set large-comm-list my-largecommunities delete
 on-match next
!
route-map upstream-in permit 100
 set community 645XX:41000 additive
 set extcommunity rt 645XX:21000
 set large-community 645XX:2:1000 additive
 set local-preference 10
!
route-map peering-in permit 50
 match community my-communities
 set comm-list my-communities delete
 on-match next
!
route-map peering-in permit 60
 match large-community my-largecommunities
 set large-comm-list my-largecommunities delete
 on-match next
!
route-map peering-in permit 100
 set community 645XX:41000 additive
 set extcommunity rt 645XX:23000
 set large-community 645XX:2:3000 additive
 set local-preference 1000
!
route-map customer-in permit 50
 match community my-communities
 set comm-list my-communities delete
 on-match next
!
route-map customer-in permit 60
 match large-community my-largecommunities
 set large-comm-list my-largecommunities delete
 on-match next
!
route-map customer-in permit 100
 set community 645XX:47000 additive
 set extcommunity rt 645XX:24000
 set large-community 645XX:2:4000 additive
 set local-preference 10000
!
route-map customer-out permit 100
 match community announce-to-customer
!
route-map peering-out permit 100
 match community announce-to-peering
!
route-map upstream-out permit 100
 match community announce-to-upstream
!
route-map own-networks permit 100
 set community 645XX:47000
!
line vty
!
end
\end{verbatim}

\section{Final Router Configuration}
\begin{verbatim}
hostname rXX
!
ip route 10.XX.0.0/16 Null0
!
interface dummy0
 ip address 10.XX.1.1/32
!
router bgp 645XX
 neighbor customer peer-group
 neighbor peering peer-group
 neighbor upstream peer-group
 neighbor 10.XX.2.1 remote-as 64499
 neighbor 10.XX.2.1 peer-group customer
 neighbor 80.81.192.1 remote-as 286
 neighbor 80.81.192.1 peer-group peering
 neighbor 80.81.192.102 remote-as 64502
 neighbor 80.81.192.102 peer-group peering
 neighbor 80.81.192.102 ttl-security hops 1
 neighbor 80.81.192.102 password somepasswordhere
 ...
 neighbor 10.200.XX.1 remote-as 65550
 neighbor 10.200.XX.1 peer-group upstream
 neighbor 10.230.XX.1 remote-as 64496
 neighbor 10.230.XX.1 peer-group upstream
 !
 address-family ipv4 unicast
  network 10.XX.0.0/16 route-map own-networks
  neighbor customer next-hop-self
  neighbor customer soft-reconfiguration inbound
  neighbor customer route-map customer-in in
  neighbor customer route-map customer-out out
  neighbor peering next-hop-self
  neighbor peering soft-reconfiguration inbound
  neighbor peering route-map peering-in in
  neighbor peering route-map peering-out out
  neighbor peering maximum-prefix 100 80 restart 1
  neighbor upstream next-hop-self
  neighbor upstream soft-reconfiguration inbound
  neighbor upstream route-map upstream-in in
  neighbor upstream route-map upstream-out out
 exit-address-family
!
bgp community-list expanded announce-to-customer permit _645XX:4[1357]000
bgp community-list expanded announce-to-peering permit _645XX:4[2367]000
bgp community-list expanded announce-to-upstream permit _645XX:4[4567]000
bgp community-list expanded my-communities permit _645XX:.*
bgp large-community-list expanded my-largecommunities permit _645XX:.*:.*
!
route-map upstream-in permit 50
 match community my-communities
 set comm-list my-communities delete
 on-match next
!
route-map upstream-in permit 60
 match large-community my-largecommunities
 set large-comm-list my-largecommunities delete
 on-match next
!
route-map upstream-in permit 100
 set community 645XX:41000 additive
 set extcommunity rt 645XX:21000
 set large-community 645XX:2:1000 additive
 set local-preference 10
!
route-map peering-in permit 50
 match community my-communities
 set comm-list my-communities delete
 on-match next
!
route-map peering-in permit 60
 match large-community my-largecommunities
 set large-comm-list my-largecommunities delete
 on-match next
!
route-map peering-in permit 100
 set community 645XX:41000 additive
 set extcommunity rt 645XX:23000
 set large-community 645XX:2:3000 additive
 set local-preference 1000
!
route-map customer-in permit 50
 match community my-communities
 set comm-list my-communities delete
 on-match next
!
route-map customer-in permit 60
 match large-community my-largecommunities
 set large-comm-list my-largecommunities delete
 on-match next
!
route-map customer-in permit 100
 set community 645XX:47000 additive
 set extcommunity rt 645XX:24000
 set large-community 645XX:2:4000 additive
 set local-preference 10000
!
route-map customer-out permit 100
 match community announce-to-customer
!
route-map peering-out permit 100
 match community announce-to-peering
!
route-map upstream-out permit 100
 match community announce-to-upstream
!
route-map own-networks permit 100
 set community 645XX:47000
!
line vty
!
end
\end{verbatim}

\section{Slides}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Setting Maximum-Prefix}
\LARGE
\begin{itemize}
  \item You can set \emph{max-prefix}
  \begin{itemize}
    \item for a whole \emph{peer-group} or
    \item for each individual BGP peer
  \end{itemize}
  \item you have to set it separately for each \emph{address family} (in our case IPv4 and IPv6)
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
conf term

router bgp 645xx
 address-family ipv4
  neighbor peering maximum-prefix 100 80 restart 1
\end{verbatim}
\end{framed}

Parameters here are:
\begin{itemize}
  \item shut down session when more then \textbf{100} IPv4 prefixes are received
  \item give a warning at \textbf{80\%} (= 80 prefixes in this case)
  \item wait \textbf{1 minute} before re-establishing the session
\end{itemize}

Show commands:
\begin{itemize}
  \item \textbf{show bgp ipv4 summary}\\
  in case max prefix is triggered the session is down with status \emph{PfxCT}
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Session Password}
\LARGE
\begin{itemize}
  \item Talk to your neighbor
  \item agree upon a password
  \item configure the password on the BGP session between you
\end{itemize}

\vspace{1cm}

\begin{framed}
\begin{verbatim}
conf t

router bgp 645xx
 neighbor 80.81.192.1yy password some-password-here

\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item \textbf{show bgp ipv4 summary}
  \item \textbf{show bgp ipv4 neighbor 80.81.192.1yy} - should show ``Peer Authentication Enabled'' at the end
\end{itemize}
\end{samepage}
%----------------------------------------------------------------

\clearpage
\begin{samepage}
\subsection*{\Huge TTL Security}
\LARGE
\begin{itemize}
  \item Using TTL security BGP TCP packets only a configurable number of hops away will be allowed.
  \item This parameter has to be configured on both peers.
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
conf t

router bgp 645xx
  neighbor 80.81.192.1yy ttl-security hops 1

\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item \textbf{show bgp ipv4 summary}
  \item \textbf{show bgp ipv4 neighbor 80.81.192.1yy} -
    should show ``\emph{External BGP neighbor may be up to 1 hops away}''
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge IXP LAN Announcement - Demonstration}
\LARGE

\begin{itemize}
  \item Never accept BGP announcements of prefixes representing IXP LANs you are connecting to
  \item Even more important: No more-speficic announcements inside these LANs.
\end{itemize}

\vspace{1cm}

Show commands:
\begin{itemize}
  \item \textbf{show ip route 80.81.192.0}
  \item \textbf{show ip route 80.81.192.1}
  \item \textbf{show bgp ipv4 summary}
\end{itemize}
\end{samepage}

%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge RFD (Route Flap Dampening)}
\LARGE
\begin{itemize}
  \item Dampening stops further propagation of flapping routes
  \item Try default values first
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
  bgp dampening
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv4 unicast dampening parameters
  \item show bgp ipv4 unicast dampening dampened-paths
  \item show bgp ipv4 unicast dampening flap-statistics
  \item show bgp ipv4 129.13.0.0/16
  \item show bgp ipv4 192.0.2.0/24
  \item show bgp ipv4 community 645\emph{xx}:23000
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge RFD with adjusted parameters}
\LARGE
\begin{itemize}
  \item Default parameters are too aggressive
  \item Start dampening later (threshold at least 6000)
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
  bgp dampening 10 750 12000 45
\end{verbatim}
\end{framed}

Do a ``\emph{show bgp ipv4 unicast dampening parameters}'' and match values to
the configured values above.

Show commands:
\begin{itemize}
  \item show bgp ipv4 unicast dampening parameters
  \item show bgp ipv4 unicast dampening dampened-paths
  \item show bgp ipv4 unicast dampening flap-statistics
  \item show bgp ipv4 129.13.0.0/16
  \item show bgp ipv4 192.0.2.0/24
  \item show bgp ipv4 community 645\emph{xx}:23000
\end{itemize}
\end{samepage}
%----------------------------------------------------------------

%----------------------------------------------------------------
\if 0
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Communities - informational}
\LARGE

\vspace{1cm}

\begin{framed}
\begin{verbatim}

\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv4 129.13.0.0/16
  \item show bgp ipv4 community 645\emph{xx}:23000
\end{itemize}
\end{samepage}
\fi
%----------------------------------------------------------------

\end{document}
